Package org.apache.commons.configuration2.tree

## Class DefaultExpressionEngineSymbols

- java.lang.Object
- - org.apache.commons.configuration2.tree.DefaultExpressionEngineSymbols

-     public final class DefaultExpressionEngineSymbols
      extends Object

  A class representing the various symbols that are supported in keys recognized by `DefaultExpressionEngine`.

  An instance of this class is associated with each instance of `DefaultExpressionEngine`. It determines which concrete symbols are used to define elements like separators, attributes, etc. within a configuration key.

  Instances are created using the nested `Builder` class. They are immutable and can be shared between arbitrary components.

  Since:
    2.0

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `static class` | `DefaultExpressionEngineSymbols.Builder` | A builder class for creating instances of `DefaultExpressionEngineSymbols`.

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static String` | `DEFAULT_ATTRIBUTE_END` | Constant for the default attribute end marker.
    `static String` | `DEFAULT_ATTRIBUTE_START` | Constant for the default attribute start marker.
    `static String` | `DEFAULT_ESCAPED_DELIMITER` | Constant for the default escaped property delimiter.
    `static String` | `DEFAULT_INDEX_END` | Constant for the default index end marker.
    `static String` | `DEFAULT_INDEX_START` | Constant for the default index start marker.
    `static String` | `DEFAULT_PROPERTY_DELIMITER` | Constant for the default property delimiter.
    `static DefaultExpressionEngineSymbols` | `DEFAULT_SYMBOLS` | An instance with default symbols.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `equals​(Object obj)` | Compares this object with another one.
    `String` | `getAttributeEnd()` | Gets the string representing an attribute end marker.
    `String` | `getAttributeStart()` | Gets the string representing an attribute start marker.
    `String` | `getEscapedDelimiter()` | Gets the string representing an escaped property delimiter.
    `String` | `getIndexEnd()` | Gets the string representing the end of an index in a property key.
    `String` | `getIndexStart()` | Gets the string representing the start of an index in a property key.
    `String` | `getPropertyDelimiter()` | Gets the string used as delimiter in property keys.
    `int` | `hashCode()` | Returns a hash code for this object.
    `String` | `toString()` | Returns a string representation for this object.

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### DEFAULT_PROPERTY_DELIMITER

          public static final String DEFAULT_PROPERTY_DELIMITER

      Constant for the default property delimiter.
      See Also:
        Constant Field Values

    - #### DEFAULT_ESCAPED_DELIMITER

          public static final String DEFAULT_ESCAPED_DELIMITER

      Constant for the default escaped property delimiter.
      See Also:
        Constant Field Values

    - #### DEFAULT_ATTRIBUTE_START

          public static final String DEFAULT_ATTRIBUTE_START

      Constant for the default attribute start marker.
      See Also:
        Constant Field Values

    - #### DEFAULT_ATTRIBUTE_END

          public static final String DEFAULT_ATTRIBUTE_END

      Constant for the default attribute end marker.
      See Also:
        Constant Field Values

    - #### DEFAULT_INDEX_START

          public static final String DEFAULT_INDEX_START

      Constant for the default index start marker.
      See Also:
        Constant Field Values

    - #### DEFAULT_INDEX_END

          public static final String DEFAULT_INDEX_END

      Constant for the default index end marker.
      See Also:
        Constant Field Values

    - #### DEFAULT_SYMBOLS

          public static final DefaultExpressionEngineSymbols DEFAULT_SYMBOLS

      An instance with default symbols. This instance is used by the default instance of `DefaultExpressionEngine`.

  - ### Method Detail

    - #### getPropertyDelimiter

          public String getPropertyDelimiter()

      Gets the string used as delimiter in property keys.
      Returns:
        the property delimiter

    - #### getEscapedDelimiter

          public String getEscapedDelimiter()

      Gets the string representing an escaped property delimiter.
      Returns:
        the escaped property delimiter

    - #### getAttributeStart

          public String getAttributeStart()

      Gets the string representing an attribute start marker.
      Returns:
        the attribute start marker

    - #### getAttributeEnd

          public String getAttributeEnd()

      Gets the string representing an attribute end marker.
      Returns:
        the attribute end marker

    - #### getIndexStart

          public String getIndexStart()

      Gets the string representing the start of an index in a property key.
      Returns:
        the index start marker

    - #### getIndexEnd

          public String getIndexEnd()

      Gets the string representing the end of an index in a property key.
      Returns:
        the index end marker

    - #### hashCode

          public int hashCode()

      Returns a hash code for this object.
      Overrides:
        `hashCode` in class `Object`
      Returns:
        a hash code

    - #### equals

          public boolean equals​(Object obj)

      Compares this object with another one. Two instances of `DefaultExpressionEngineSymbols` are considered equal if all of their properties are equal.
      Overrides:
        `equals` in class `Object`
      Parameters:
        `obj` - the object to compare to
      Returns:
        a flag whether these objects are equal

    - #### toString

          public String toString()

      Returns a string representation for this object. This string contains the values of all properties.
      Overrides:
        `toString` in class `Object`
      Returns:
        a string for this object